// $Id: CameraDemoAgentImpl.java,v 1.2 2000/05/19 19:55:25 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent;

import net.hivecell.hive.agent.desktop.ClickAgentImpl;
import net.hivecell.hive.agent.image.CameraAgentImpl;
import net.hivecell.hive.agent.image.ImageDisplayAgentImpl;
import net.hivecell.hive.agent.AgentInitializationException;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.cell.Cell;

import java.rmi.RemoteException;

public class CameraDemoAgentImpl 
extends AgentImpl {

    public CameraDemoAgentImpl() 
    throws RemoteException { 
	super(); 
    }

    public void doBehavior() {
	// create the camera demo and then pull ourselves down
	try { 
	    Thread.sleep( 1000 ); 
	} catch( InterruptedException e ) { }
      
	diePlease();

    }

    public void doLocalSetup() throws AgentInitializationException  {
	// this should look for all these things -- but we're lazy, so
	// just create them and we'll fix this later
	try {
	    AgentImpl cam = myCell.createNewAgent( (CameraAgentImpl.class).getName() );
	    cam.blockUntilReady();

	    AgentImpl click = myCell.createNewAgent( (ClickAgentImpl.class).getName() );
	    click.blockUntilReady();

	    AgentImpl disp = myCell.createNewAgent( (ImageDisplayAgentImpl.class).getName() );
	    disp.blockUntilReady();

	    disp.connectTo( cam );
	    cam.connectTo( click );

	} catch( Exception e ) {
	    Debug.warning( "CameraDemo failed", e );

	}
    
    }

}
