// $Id: ChatMessage.java,v 1.1 2000/05/18 22:04:48 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

/**
 ** message object passed around by chat agents.
 **/

package net.hivecell.hive.agent.desktop;

import net.hivecell.hive.agent.EventSendingAgent;
import net.hivecell.hive.agent.desktop.ChatAgent;
import java.rmi.RemoteException;
import java.io.Serializable;

public class ChatMessage implements Serializable {
    
    private EventSendingAgent sender;
    private String sname;  // So you can read a message w/o worrying about a remoteException.  ie. message is independent of sender.
    private String message;
    private boolean isPrivate;
    
    public ChatMessage(EventSendingAgent s, String m, boolean p) throws RemoteException {
	sender = s;
	if (s instanceof ChatAgent)
	    sname = ((ChatAgent)sender).getChatName();
	else if (s instanceof ChatGroupServerAgent)
	    sname = ((ChatGroupServerAgent)sender).getGroupName();
	else sname = "(neither Chat nor GroupCell Agent)";
	message = m;
	isPrivate = p;
    }
    
    public String read() {
	if (sender instanceof ChatAgent)
	    return (message);
	else  // Some sort of message from the server or a non-ChatAgent agent.
	    return ("<FONT COLOR=\"RED\"" + sname + ": " + message + "</FONT>");
    }
    
    public EventSendingAgent getSender() { return (sender); }

    public String getSName() { return (sname); }
    
    public boolean isPrivate() { return (isPrivate); }

    
    // In case any non-ChatAgent gets this message
    public String toString() {
	if (isPrivate) return ("<Private>");
	else return ("Sender: " + sender + "\n" + "Sender's name: " + sname + "\nMessage: " + message);
    }
};
