package net.hivecell.hive.agent.desktop;

import net.hivecell.hive.agent.AgentInitializationException;
import net.hivecell.hive.agent.EventReceivingAgent;
import net.hivecell.hive.agent.EventTransceivingAgentImpl;
import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.support.Debug;

import java.rmi.RemoteException;


/**
 * this is a simple class that merely echos back an event sent to it
 * -- what it actually does is just encapsulate the HiveEvent in
 * another HiveEvent which is sent right back to the agent which sent
 * the first hive even 
 */
public class EchoAgentImpl
extends EventTransceivingAgentImpl 
implements EchoAgent {

    public EchoAgentImpl() throws RemoteException { super(); }

    public void doLocalSetup() throws AgentInitializationException  { 
	super.doLocalSetup(); 
	setIsReady( true ); 

    }

    public void doBehavior() { waitUntilDeath(); }

    public void notify( HiveEvent event ) {
	super.notify( event );
	
	if( event.getSource() instanceof EventReceivingAgent ) {
	    EventReceivingAgent[] destinationAgents = { (EventReceivingAgent)event.getSource() };
	    eventSendingHelper.broadcastEventTo( event, destinationAgents, null );
	}

    }
    
}



