// $Id: FlashingDotAgentImpl.java,v 1.2 2000/05/19 19:55:27 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

// Simple agent to display events as a flashing dot
// This evolved from an earlier KeystrokeDisplayAgent

package net.hivecell.hive.agent.desktop;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.agent.EventReceivingAgentImpl;
import net.hivecell.hive.agent.Agent;
import net.hivecell.hive.agent.AgentInitializationException;
import net.hivecell.hive.shadow.ShadowNotFoundException;
import net.hivecell.hive.shadow.cell.ComponentManagerShadow;
import java.rmi.RemoteException;
import java.awt.*;
import java.util.*;
import net.hivecell.hive.description.Description;

public class FlashingDotAgentImpl 
extends EventReceivingAgentImpl {

    protected transient FlashingDotCanvas displayCanvas;
    // Agent parameters
    protected int updateInterval = 100;
    protected transient ComponentManagerShadow acms = null;

    public void setUpdateInterval(int i) { updateInterval = i; }
    public int getUpdateInterval() { return updateInterval; }

    public FlashingDotAgentImpl() 
	throws RemoteException { 
	super(); 
    }
  
    public void doLocalSetup() throws AgentInitializationException  {
	super.doLocalSetup();

	try {
	    acms = getComponentManagerShadow();
	}
	catch (ShadowNotFoundException e) {
	    throw new AgentInitializationException("This agent cannot run on a cell without a UI.");
	}


	Description desc = new Description(this, "FlashingDotAgent");
	desc.addSemantic("role", "screen-widget", null, null);
	desc.addSemantic("role", "event-display", null, null);
	setDescription(desc);
	
	displayCanvas = new FlashingDotCanvas();
	acms.acceptComponentFrom(this, displayCanvas, "Flashing Dot Display");
    }

    public void doBehavior() {
	// Now main loop
	while( !timeToStop ) {
	    displayCanvas.updateDisplay();
	    try {
		Thread.sleep(updateInterval);
	    } catch (InterruptedException e) {}
	}
	doLocalCleanup();
    }

    // callback method. Manage display
    public void notify(HiveEvent event) {
	super.notify(event);
	displayCanvas.growAndWarmDot();
    }
}
