// $Id: FlashingDotCanvas.java,v 1.1 2000/05/18 22:04:48 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

// Canvas for flashing dot agent
// This evolved from an earlier KeystrokeDisplayCanvas

package net.hivecell.hive.agent.desktop;
import java.awt.*;
import java.awt.event.*;
import net.hivecell.hive.support.BaseCanvas;
import net.hivecell.hive.support.Debug;

public class FlashingDotCanvas extends BaseCanvas {
  protected int size, drawnSize;
  protected int color, drawnColor;
  protected final int colorMax = 200;

  public FlashingDotCanvas() {
    super();

    setBackground(Color.black);
    setSize(120, 120);
    setVisible(true);
  }
  
  // when a keystroke is received, max out radius and increase colour
  public void growAndWarmDot() {
    size = 5;
    color += 5;
    if (color > colorMax)
      color = colorMax;
  }

  // everytime we update the display, ramp down the colour and radius
  public void updateDisplay() {
    color -= 1;
    if (color <= 0)
      color = 0;
    
    size -= 1;
    if (size < 0)
      size = 0;

    // check if we really have to redraw
    if (size != drawnSize || color != drawnColor)
      render();
    drawnSize = size;
    drawnColor = color;
  }
  
  public void render(Graphics g) {
    Dimension s = getSize();
    // clear the window
    g.setColor(getBackground());                  
    g.fillRect(0, 0, s.width, s.height);

    // Calculate how red the dot should be basd on the square of the color
    float redShift = (float)color / colorMax;
    redShift = redShift * redShift;               // square the value

    // now draw the circle
    int xSize = ((size + 5) * s.width) / 13;
    int ySize = ((size + 5) * s.height) / 13;
    g.setColor(new Color(redShift, 0, 1.0f - redShift));
    g.fillOval((s.width - xSize) / 2, (s.height - ySize) / 2,
               xSize, ySize);
  }
}
