// $Id: MetronomeAgentImpl.java,v 1.1 2000/05/18 22:04:48 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.


package net.hivecell.hive.agent.desktop;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.agent.EventSendingAgentImpl;
import net.hivecell.hive.agent.Agent;
import java.rmi.RemoteException;
import java.awt.*;
import java.awt.event.*;

/** Simple class that just sends out events at a regular pace. Useful as
 ** a heartbeat or debugging tool.
 **/
public class MetronomeAgentImpl 
extends EventSendingAgentImpl 
implements MetronomeAgent {

    int pulseInterval = -1;
    Object eventObject = null;

    public MetronomeAgentImpl() 
    throws RemoteException { 
	super(); 
    }

    public void doBehavior() {
        while (!timeToStop) {
            if (pulseInterval >= 0)
                eventSendingHelper.broadcastEvent(eventObject);
            try {
                if (pulseInterval >= 0)           // are we pulsing?
                    Thread.sleep(pulseInterval);  // yes, sleep appropriately
                else                              
                    synchronized(this) {          // no pulse, so just
                        wait();                   // wait for setPulseInterval
                    }
            } catch (InterruptedException ex) {
                Debug.notice("Interrupted!");
            }
        }
    }

    public void setPulseInterval(int i) {
        pulseInterval = i;
        synchronized(this) {
            notify();                             // wake up doBehavior()
        }
    }
    public int getPulseInterval() { return pulseInterval; }
    public void setEventObject(Object o) { eventObject = o; }
    public Object getEventObject() { return eventObject; }
}




