// $Id: PocketServerAgent.java,v 1.1 2000/05/18 22:04:48 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

//stock grabber agent written by Blair Dunn 3/14/99
//Based on Will Logan's PocketServer code.

package net.hivecell.hive.agent.desktop;

import net.hivecell.hive.support.Debug;
import net.hivecell.hive.*;
import net.hivecell.hive.agent.EventSendingAgentImpl;
import net.hivecell.hive.support.pocketserver.NASDAQGrabber;

import java.rmi.Remote;
import java.rmi.RemoteException;


/* Agent that queries a particular stock price every few minutes
 * and compares the results to a high/low/delta.  default values
 * are requested at creation.
 */

public interface PocketServerAgent
extends Remote {

    public String getSymbol() throws RemoteException;
    public void setSymbol(String s) throws RemoteException;

    public int getDelay() throws RemoteException;
    public void setDelay(int d) throws RemoteException;

    public double getHighthreshold() throws RemoteException;
    public void setHighthreshold(double v) throws RemoteException;

    public double getLowthreshold() throws RemoteException;
    public void setLowthreshold(double v) throws RemoteException;

    public double getNetchangehighthreshold() throws RemoteException;
    public void setNetchangehighthreshold(double v) throws RemoteException;

    public double getNetchangelowthreshold() throws RemoteException;
    public void setNetchangelowthreshold(double v) throws RemoteException;

    public boolean getLoadDefaultValues() throws RemoteException;
    public void setLoadDefaultValues(boolean b) throws RemoteException;

}
