// $Id: StringSendingAgentImpl.java,v 1.2 2000/05/19 19:55:27 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.desktop;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.*;
import net.hivecell.hive.agent.Agent;
import net.hivecell.hive.agent.EventSendingAgentImpl;
import net.hivecell.hive.agent.AgentInitializationException;
import net.hivecell.hive.shadow.ShadowNotFoundException;
import net.hivecell.hive.shadow.cell.ComponentManagerShadow;
import java.rmi.RemoteException;
import java.awt.*;
import java.awt.event.*;

public class StringSendingAgentImpl 
extends EventSendingAgentImpl {

    protected transient ComponentManagerShadow acms;

    protected transient StringSenderDialog c = null;

    public StringSendingAgentImpl() throws RemoteException { super(); }

    public void doLocalSetup() throws AgentInitializationException  {

	super.doLocalSetup();
       	try {
	    acms = getComponentManagerShadow();
	}
	catch (ShadowNotFoundException e) {
	    throw new AgentInitializationException("This agent cannot run on a cell without a UI.");
	}      

	c = new StringSenderDialog(this);
	acms.acceptComponentFrom(this, c, "Send a string");

    }

    /** Create a canvas and listen to it for mouseclicks. **/
    public void doBehavior() {
	waitUntilDeath();
    }

    public void send(String s){
	eventSendingHelper.broadcastEvent(s);
    }
}

class StringSenderDialog extends Container {
    TextField ta;
    Button submit;
    StringSendingAgentImpl agent;

    StringSenderDialog(StringSendingAgentImpl ssai){
	ta = new TextField(30);
	submit = new Button("Send");
	setLayout(new FlowLayout());
	add(ta);
	add(submit);
	agent = ssai;
	ta.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e){
		String sendthis = ta.getText();
		ta.setText("");
		agent.send(sendthis);
	    }
	});
	submit.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e){
		String sendthis = ta.getText();
		ta.setText("");
		agent.send(sendthis);
	    }
	});
    }

} 
