// $Id: EventNumberTranslatingAgentImpl.java,v 1.1 2000/05/18 22:04:52 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.filter;

import net.hivecell.hive.support.Debug;
import net.hivecell.hive.*;
import net.hivecell.hive.event.*;
import net.hivecell.hive.agent.EventTransceivingAgentImpl;
import java.lang.*;
import java.util.*;

/** Agent that turns generic events into numbers. When this agent
 ** receives an event, it rebroadcasts it to its listeners with an
 ** Integer. The Integer sent is a property of the agent.
 ** @version $Revision: 1.1 $
 ** @auathor Nelson Minar <nelson@media.mit.edu>
 **/
public class EventNumberTranslatingAgentImpl 
extends EventTransceivingAgentImpl {

    public int valueToSend = 0;
    protected Integer valueObject = new Integer(valueToSend);
    
    public EventNumberTranslatingAgentImpl() 
	throws java.rmi.RemoteException { 
	super(); 
    }

    /** When an event is received, send a number object. **/
    public void notify(HiveEvent event) {
	super.notify(event);
	eventSendingHelper.broadcastEvent(valueObject);
    }

    public void doBehavior() {
	waitUntilDeath();
    }
    

    public void setValueToSend(int v) {
	valueToSend = v;
	valueObject = new Integer(v);
    }
    public int getValueToSend() { return valueToSend; }
}
