// $Id: HTTPAccessTranslatingAgentImpl.java,v 1.1 2000/05/18 22:04:52 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.filter;

import net.hivecell.hive.support.Debug;
import net.hivecell.hive.*;
import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.agent.EventTransceivingAgentImpl;
import net.hivecell.hive.agent.desktop.PointColor;
import java.lang.*;
import java.util.*;

public class HTTPAccessTranslatingAgentImpl 
extends EventTransceivingAgentImpl {

    // used to store the hash between the item gotten and the PointColor
    private Hashtable translatorTable = new Hashtable();

    public HTTPAccessTranslatingAgentImpl() 
    throws java.rmi.RemoteException {
        super();
    }

    public void doBehavior() {
	waitUntilDeath();
    }
    
    // just takes the block that will come as an event in a string,
    // breaks into many different strings on the '\n', and then emits
    // each string as a separate event
    public void notify(HiveEvent event) {
        super.notify(event);
        Object eventData = event.getEventData();
        if (eventData instanceof String ) { 
            // if it is a string -- just split it and emit it as many times
            // as necessary
            StringTokenizer st = new StringTokenizer((String)eventData, "\n");
            int amount = st.countTokens();
            for (int count=0;count != amount - 1;count++) {
                String token = st.nextToken();
                handleWebHit(token);
            }
        } else 
            eventSendingHelper.broadcastEvent(eventData);
    }
  
    public void handleWebHit(String line) {
        // pull out what the web access is getting
        String GET = line.substring(line.indexOf("GET") + 4);
        GET = GET.substring(0, GET.indexOf(" "));

        Object placement = null;
        if ( (placement = translatorTable.get(GET)) == null ) {
            placement = (new PointColor((float)Math.random(), 
                                        (float)Math.random(),
                                        (float)Math.random()));
            translatorTable.put(GET, placement);
        }
        eventSendingHelper.broadcastEvent(placement);
    }
}
