// $Id: CameraAgentImpl.java,v 1.2 2000/05/19 19:55:31 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.


package net.hivecell.hive.agent.image;

import net.hivecell.hive.agent.Agent;
import net.hivecell.hive.agent.AgentInitializationException;
import net.hivecell.hive.cell.*;
import net.hivecell.hive.event.*;
import net.hivecell.hive.shadow.*;
import net.hivecell.hive.shadow.thing.QuickCam;
import net.hivecell.hive.shadow.thing.QuickCamImpl;
import net.hivecell.hive.support.*;

import java.awt.*;
import java.rmi.*;

/**
 * This agent provides an interface to a QuickCam shadow. Most of the
 * intelligence is inherited from the superclass.
 */
public class CameraAgentImpl 
extends ImageCreationAgentImpl {

    /** 
     * The actual camera shadow
     */
    QuickCam shadow;

    /** 
     * This constructor is just here to throw RemoteException
     * 
     * @exception RemoteException 
     */
    public CameraAgentImpl() 
    throws RemoteException {
	super();
    }

    /** 
     * Grab the QuickCam shadow from the ShadowDB -- the init class in
     * ImageCreationAgentImpl should have an exception we can throw 
     */
    public void init() {
	try {
	    shadow = (QuickCam)myCell.getShadow( (QuickCamImpl.class).getName() );

	} catch( ShadowNotFoundException error ) {
	    Debug.error( "could not find a quick cam to bind to" );
	    diePlease();
	    //	    myCell.killAgent( this );
	    return;
	    
	}

    }

    /** 
     * Grab an image from the actual camera. This is a blocking call
     * and takes several seconds to return.
     * 
     * @return The image that has been requested.  
     */
    public SerializableImage fetchImage() {
	return (SerializableImage)shadow.getPPM();

    }

}






