// $Id: QueueEntry.java,v 1.1 2000/05/18 22:04:58 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.


package net.hivecell.hive.agent.image;
import java.awt.*;
import java.rmi.RemoteException;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.*;
import net.hivecell.hive.support.*;
import net.hivecell.hive.shadow.*;
import net.hivecell.hive.event.*;


class QueueEntry implements java.io.Serializable {
    /** The source of the image
     * 
     */
    protected ImageSourceAgent source;
    /** The ImageEvent, which contains the ID number.
     * 
     */
    protected ImageEvent event;

    /** Create a new data structure.
     * 
     * @param source The source of the image
     * @param event The ImageEvent including the id number
     */
    public QueueEntry(ImageSourceAgent source,
		      ImageEvent event) {
	this.source = source;
	this.event = event;
    }

    /**      * 
     * @return The source of the image
     */
    public ImageSourceAgent getSource() {
	return source;
    }

    /**      * 
     * @return The ImageEvent including the ID number.
     */
    public ImageEvent getEvent() {
	return event;
    }
}
