// $Id: WebImageAgentImpl.java,v 1.1 2000/05/18 22:04:58 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.image;
import net.hivecell.hive.support.*;
import java.awt.*;
import java.net.*;

/** This class retrieves Images from the net and makes them available as a ImageSource.
 * 
 * @author Oliver Roup (oroup@mit.edu)
 */
public class WebImageAgentImpl 
extends ImageCreationAgentImpl 
implements WebImageAgent {

    /** Is the agent configured?
     * 
     */
    boolean configured;
    /** The URL to get the image from.
     * 
     */
    String imageURL= new String("http://hive.www.media.mit.edu/projects/hive/hive-logo.gif");

    /** Default constructor
     * 
     * @exception java.rmi.RemoteException 
     */
    public WebImageAgentImpl() 
    throws java.rmi.RemoteException {
	super();
    }
    
    /** 
     * Get the value of imageURL.
     * 
     * @return Value of imageURL.
     */
    public String getImageURL() {return imageURL;}
    
    /** 
     * Set the value of imageURL.
     * 
     * @param v Value to assign to imageURL.
     */
    public void setImageURL(String  v) {
	this.imageURL = v; 	
	configured = true;
    }
    
    /** Set up the WebImageAgent.
     * 
     */
    public void init() { }

    /** Get the image from the net.
     * 
     */
    public SerializableImage fetchImage() {
	while(!configured)
	    try { Thread.sleep(200); } catch (Exception e) { }
	try { 
	    System.out.println("Fetching "+imageURL);
	    Image i = Toolkit.getDefaultToolkit().getImage(new URL(imageURL));
	    MediaTracker mt = new MediaTracker(new Canvas());
	    mt.addImage(i, 0);
	    mt.waitForAll();
	    SerializableImage si = new PPM(i);
	    System.out.println("Fetched "+imageURL+", dim "+si.getSize());
	    return si;
	} catch (Exception e) { return null; }
    }
}





