// $Id: CameraFinderAgentImpl.java,v 1.1 2000/05/18 22:05:01 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.wearable;

import net.hivecell.hive.*;
import net.hivecell.hive.shadow.*;
import net.hivecell.hive.agent.*;
import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.event.cell.*;
import net.hivecell.hive.agent.EventTranslatingAgentImpl;
import net.hivecell.hive.agent.image.*;
import net.hivecell.hive.agent.EventSendingHelper;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.support.CellAddress;
import net.hivecell.hive.support.CellConnectException;
import net.hivecell.hive.support.MalformedHiveURLException;
import java.rmi.RemoteException;
import net.hivecell.hive.cell.RemoteCell;
import net.hivecell.hive.agent.ConnectAgentHelper;
import net.hivecell.hive.description.AgentSet;
import net.hivecell.hive.cell.*;
import net.hivecell.hive.shadow.ShadowNotFoundException;
import java.util.Vector;

public class CameraFinderAgentImpl extends GenericResourceFinderAgentImpl {
    Agent closestCam = null;
    int counter = 0;
    EventSendingHelper esh;
    ImageDisplayAgentImpl idai = null;
    
    public CameraFinderAgentImpl() 
        throws RemoteException {
        super();
    }

    public void doBehavior() {
        super.doBehavior();
        setResourceType("CAMERA AGENT"); //searches for agents with nickname:CAMERA AGENT in their rdf files
    }
    
    public void resourceAction(AgentSet resources) {
            Vector agentToBroadcastEventTo = new Vector();
            Debug.notice("Camera agents at this location: " + resources.size());
            if (resources.size() == 0) {
                Debug.notice("No cameras available...");
                return;
            }
            
            closestCam = (Agent)resources.pickOne();            

            try {
                if (counter++ == 0) {
                    Debug.notice("-------------->[creating image display]<------------");
                    idai = (ImageDisplayAgentImpl)myCell.createNewAgent("net.hivecell.hive.agent.image.ImageDisplayAgentImpl");
                    esh = new EventSendingHelper(this, myCell);
                }

            } catch (ClassNotFoundException error) {
                Debug.error("ClassNotFoundException while trying to create image display...");

            } catch( InstantiationException error ) {
		Debug.error("InstnatiationException while trying to create image display...");

	    }
                
            try {
                Thread.sleep( 1000 );
            } catch( InterruptedException error ) { }            

            Debug.notice("-------------->[now waiting before connecting to camera!]<---------------");
            
            idai.connectTo( closestCam );
            esh.addListener( (EventReceivingAgent)closestCam );
            agentToBroadcastEventTo.addElement( closestCam );
	    EventReceivingAgent[] destinationAgents = new EventReceivingAgent[agentToBroadcastEventTo.size()];
	    agentToBroadcastEventTo.copyInto( destinationAgents );
            esh.broadcastEventTo( super.he, destinationAgents, null );       
    }
    
}

