// $Id: DJFinderAgentImpl.java,v 1.1 2000/05/18 22:05:01 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.wearable;

import net.hivecell.hive.*;
import net.hivecell.hive.shadow.*;
import net.hivecell.hive.agent.*;
import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.agent.EventTranslatingAgentImpl;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.support.CellAddress;
import net.hivecell.hive.support.CellConnectException;
import java.rmi.RemoteException;
import net.hivecell.hive.cell.RemoteCell;
import net.hivecell.hive.agent.ConnectAgentHelper;
import net.hivecell.hive.description.AgentSet;
import net.hivecell.hive.cell.*;
import java.util.Vector;

public class DJFinderAgentImpl extends GenericResourceFinderAgentImpl {
    DJAgent lastDJRequested = null;
    Vector playlist = new Vector();

    public DJFinderAgentImpl() throws RemoteException { super(); }
  
    /**
     * Main thread of execution for the agent
     */
    public void doBehavior(){
        super.doBehavior();
        setResourceType("DJ AGENT");
        initPlayList();
    }

    public void initPlayList(){
        playlist.removeAllElements();   // Reset it
        String[] songlist = {
            
            "/mas/u/kenshin/canitbe.mp3",
            "/mas/u/kenshin/deer.mp3",
            "/mas/u/kenshin/gather.mp3"
        };
        
            
            /*
            "BillieHolliday-IveGotMyLoveToKeepMeWarm.mp3",
            "CabCalloway-AreYouHepToTheJive.mp3",
            "CabCalloway-EverybodyEatsWhenTheyComeToMyHouse.mp3",
            "ChickWeb-StricktlyJive.mp3",
            "ChickWeb-TheDipsyDoodle.mp3",
            "CountBasie-OneOClockBoogie.mp3",
            "CountBasie-ShineOnHarvestMoon.mp3",
            "DocsRhythmCats-FlyingHome.mp3",
            "EllaFitzgerald-FascinatinRhythm.mp3",
            "JimmieLunceford-Posin.mp3",
            "JimmieLunceford-TAintWhatYouDo.mp3",
            "ManhattanTransfer-ChooChooChBoogie.mp3",
            "PeggyLee-Fever.mp3",
            "SwingKids-BeiMirBistDuSchon.mp3",
            "SwingKids-LifeGoesToAParty.mp3",
            "SwingKids-ShoutAndFeelIt.mp3",
            "SwingKids-SingSingSing.mp3"};
            */
            
        Vector templist = new Vector();
       	for(int i=0; i < songlist.length;i++){
            templist.addElement(songlist[i]);
	}
        while (!templist.isEmpty()) {
            int pickN = (int) (templist.size()*Global.random.nextDouble());
            //playlist.addElement("http://www.media.mit.edu/~rhodes/mp3/"+templist.elementAt(pickN));
            playlist.addElement(templist.elementAt(pickN));
            templist.removeElementAt(pickN);
        }
    }
  

    public void resourceAction(AgentSet resources){
        try {
            Debug.notice("DJ agents at this location: "+resources.size());
            //resources.printTree();
            DJAgent dj = (DJAgent)resources.pickOne();
            if ((lastDJRequested != null) && (dj != lastDJRequested)) {  // We've moved
                lastDJRequested.removeRequests(this);
                ((DJAgentImpl)lastDJRequested).stopDJ(this);
                initPlayList();    // Set a new randomized playlist for next time
                for (int i=0; i < playlist.size();i++) {
                    Debug.notice("----------->[REQUESTING....]:        " + (String)playlist.elementAt(i));
                    dj.requestSong(this, (String)playlist.elementAt(i));
                    }
            }
            else {
                if (dj != null) {
                    for (int i=0; i < playlist.size();i++) {
                        Debug.notice("----------->[REQUESTING....]:        " + (String)playlist.elementAt(i));
                        dj.requestSong(this, (String)playlist.elementAt(i));
                    }
                }
            }
            lastDJRequested = dj;
        }
        catch (Exception e) {}
    }
}
