// $Id: Location.java,v 1.1 2000/05/18 22:05:01 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.


/**
 * Message.java
 *  This is a general purpose Location class.
 * Eventually it will implement conversions from Locusts,
 * GPS, etc.  Right now, only the locust and room# types is implemented.
 * Created: Fri May 31 00:08:07 1999
 *
 * @author Bradley Rhodes
 * @version $Revision: 1.1 $
 */
package net.hivecell.hive.agent.wearable;

import java.io.Serializable;

public class Location implements Serializable {
    String locationType;   // This is the authoritative type -- all other fields are derivative.
    String locust;
    String bldg;
    String room;
    
    public Location(String vlocationType, String vlocust, String vbldg, String vroom) {
        locationType = vlocationType;
        locust = vlocust;
        bldg = vbldg;
        room = vroom;
    }

    public Location() {
        locationType = "none";   // currently "none", "locust", or "room"
        locust = "";
        bldg = "";
        room = "";
    } 
    
    /**
     * Get the value of locationType.
     * @return Value of locationType.
     */
    public String getLocationType() {return locationType;}
    
    /**
     * Set the value of locationType.
     * @param v  Value to assign to locationType.
     */
    public void setLocationType(String  v) {this.locationType = v;}
    
    /**
     * Get the value of locust.
     * @return Value of locust.
     */
    public String getLocust() {return locust;}
    
    /**
     * Set the value of locust.
     * @param v  Value to assign to locust.
     */
    public void setLocust(String  v) {this.locust = v;}
    
    /**
       * Get the value of bldg.
       * @return Value of bldg.
       */
    public String getBldg() {return bldg;}
    
    /**
       * Set the value of bldg.
       * @param v  Value to assign to bldg.
       */
    public void setBldg(String  v) {this.bldg = v;}
    
    /**
       * Get the value of room.
       * @return Value of room.
       */
    public String getRoom() {return room;}
    
    /**
       * Set the value of room.
       * @param v  Value to assign to room.
       */
    public void setRoom(String  v) {this.room = v;}
    
    public String toString() {
        if (locationType.equals("locust")) return(locust);
        else if (locationType.equals("room")) return(bldg+"-"+room);
        return("NOLOC");
    }
} // Location
