// $Id: LocustToLocationTranslatingAgentImpl.java,v 1.2 2000/05/19 19:55:34 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.wearable;

import net.hivecell.hive.support.Debug;
import net.hivecell.hive.*;
import net.hivecell.hive.event.*;
import net.hivecell.hive.agent.EventTransceivingAgentImpl;
import net.hivecell.hive.agent.ConnectAgentHelper;
import net.hivecell.hive.agent.AgentInitializationException;
import net.hivecell.hive.cell.*;
import java.util.Hashtable;
import java.lang.*;
import java.util.*;
import net.hivecell.hive.agent.wearable.Location;

/** Agent that turns Locust ID numbers (e.g. "Loc  18. 85. 0. 1" into 
    location names like "e15-305"
 **/
public class LocustToLocationTranslatingAgentImpl extends EventTransceivingAgentImpl {
    public int valueToSend = 0;
    protected Integer valueObject = new Integer(valueToSend);
    protected static String nowhere;
    protected Hashtable idToLoc;                // mapping
    ConnectAgentHelper connectAgentHelper = null;

    public LocustToLocationTranslatingAgentImpl() throws java.rmi.RemoteException { 
        super();
        // initialize the mapping
        idToLoc = new Hashtable();
        nowhere = "NOLOC";
        /*
        idToLoc.put("Loc  18. 85. 0. 1", new Location("locust", "Loc  18. 85. 0. 1", "E15", "305"));
        idToLoc.put("Loc  18. 85. 0. 2", new Location("locust", "Loc  18. 85. 0. 2", "E15", "301"));
        idToLoc.put("Loc  18. 85. 0. 3", new Location("locust", "Loc  18. 85. 0. 3", "E15", "301"));
        idToLoc.put("Loc  18. 85. 0. 4", new Location("locust", "Loc  18. 85. 0. 4", "E15", "383a"));
        idToLoc.put("Loc  18. 85. 0. 5", new Location("locust", "Loc  18. 85. 0. 5", "E15", "386"));
        idToLoc.put("Loc  18. 85. 0. 6", new Location("locust", "Loc  18. 85. 0. 6", "E15", "095"));
        idToLoc.put("Loc  18. 85. 0. 11", new Location("locust", "Loc  18. 85. 0. 11", "E15", "301a"));
        idToLoc.put("Loc  18. 85. 0. 12", new Location("locust", "Loc  18. 85. 0. 12", "E15", "301b"));
        */
        idToLoc.put("1", new Location("locust", "Loc  18. 85. 0. 1", "E15", "301a"));
        idToLoc.put("2", new Location("locust", "Loc  18. 85. 0. 2", "E15", "301b"));
        idToLoc.put("3", new Location("locust", "Loc  18. 85. 0. 3", "E15", "301c"));
      
    }

    /** When an event is received, send a number object. **/
    public void notify(HiveEvent event) {
        super.notify(event);
        
        Object data = event.getEventData();
        if (!(data instanceof String)) {
            Debug.notice("Ignoring unknown event " + event);
            return;
        }
        
        String locustID = (String)data;

        Debug.notice("Got locustID: " + locustID);
        if (nowhere.equals(locustID)) {
            Debug.notice("We're nowhere");
            eventSendingHelper.broadcastEvent(new Location());
        }
        else {
            Location newLoc = (Location)idToLoc.get(locustID);
            Debug.notice("NewLoc = "+newLoc);
            System.out.println("-------->[BUILDING]:       " + newLoc.getBldg());
            System.out.println("-------->[ROOM]:           " + newLoc.getRoom());
            
            if (newLoc == null)
                Debug.notice("Ignoring unknown location " + locustID);
            else {
                eventSendingHelper.broadcastEvent(newLoc);
            }
        }
    }

    public void doLocalSetup() throws AgentInitializationException {
	super.doLocalSetup();
        connectAgentHelper = new ConnectAgentHelper(this, myCell);
    }
    
    public void doBehavior() {
        // Wire it up
        for (int i=1; 
             (i<5) && (!connectAgentHelper.connectMeTo("net.hivecell.hive.agent.wearable.LocustShadowAgentImpl",null));
             i++) {
            Debug.notice("Still waiting for a LocustShadowAgentImp to hook up to...");
            try { Thread.sleep(1000 * i); } catch (Exception e) {}
        }
    }
}

