package net.hivecell.hive.event;

import org.w3c.dom.*;

/**
 * this is asubclass of the hive event which is specially made just to
 * transmit around the XML DOM stuff so we can do the external events
 * from outside sources.  
 */
public class OutgoingExternalEvent
extends ExternalEvent {
    
    /**
     * the value of the data tag for the XML passed to us
     */
    protected String dataValue;

    /**
     * the UID which originated this event
     */
    protected String UID;


    /**
     * create a new ExternalEvent that takes the source of the event,
     * the event number, and as the event data is the Document that is
     * the top level of the event data
     *
     * @param source the source of the event
     * @param UIDSource the UID which is the origin of the 
     * @param count the evnet number
     * @param eventData the document node that we want to stuff
     */
    public OutgoingExternalEvent( Object source, String UIDSource, long count, Document eventData ) {
	super( source, count, eventData );
	this.UID = UIDSource;

    }

    /**
     * return the UID that originated this event
     *
     * @return the UID for the sender
     */
    public String getSenderUID() {
	return this.UID;

    }


}
