// $Id: DJShadow.java,v 1.1 2000/05/18 22:05:03 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.shadow;

import net.hivecell.hive.Global;
import net.hivecell.hive.cell.Cell;
import net.hivecell.hive.support.Debug;

import java.io.*;
import java.util.Vector;

// Most of this is based on the JukeBoxShadow, but with some enhancements
public interface DJShadow
extends EventPublisherShadow {

    /**
     * tell us whether or not we are playing a song
     *
     * @return true if we are playing a song, false otherwise
     */
    public boolean getPlayingSong();

    /**
     * the "is device there" method -- since we are using a software
     * player, it is always "there".  we shoudl modify this to check
     * to make sure we have the binary though
     *
     * @return true always 
     */
    public boolean isDeviceThere();

    /**
     * pause the player
     */
    public void pause();

    /**
     * ask the player to start playing again -- currently unsupported 
     */
    public void play();

    /**
     * stop playing the mp3 -- this will also notify all our
     * subscribers that we have stopped playing 
     */
    public void stop();

    /**
     * set the volume on the mp3 -- we make a call out to the oss
     * mixer with the volume number
     *
     * @param v the volume we want to set it to 
     */
    public void volume( int v );

    /**
     * play a particular song.  if the song is not one of our choices,
     * then the mp3 player will just exit and nothing will happen --
     * not necessarilyt the best thing.  something real should happen
     * -- like an exception or something
     *
     * @param pick the song that we want to play 
     */
    public void playSong( String pick );

}
