// $Id: FileStreamShadowImpl.java,v 1.1 2000/05/18 22:05:03 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.shadow;

import net.hivecell.hive.cell.Cell;
import net.hivecell.hive.support.Debug;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;


public class FileStreamShadowImpl
extends StreamShadowImpl
implements FileStreamShadow {

    protected String fileName = "/dev/ttyD0";

    /**
     * set the name of the file we want to communicate through
     *
     * @param s the name of the file
     */
    public void setFileName( String s ) { if( isReady() ) return; fileName = s; }

    /**
     * get the name of the file we want to communicate through
     *
     * @return the name of the file
     */
    public String getFileName() { return fileName; }

    public boolean isDeviceThere() { return true; }

    /**
     * do the initialization -- in this case it set up the file line
     */
    public void init() 
    throws ShadowInitializationException {
	try {
	    File f = new File( fileName );
	    is = new FileInputStream( f );
	    os = new FileOutputStream( f );
	} catch( IOException error ) {
	    Debug.error( "couldn't talk to " + fileName, error );
	    throw new ShadowInitializationException( "couldn't talk to file " + fileName, error );
	}
	Debug.notice( "all done setting up file channel" );

	setReady( true );

    }

}
