// $Id: FileGrowthShadow.java,v 1.1 2000/05/18 22:05:04 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.


package net.hivecell.hive.shadow.sysinfo;

import net.hivecell.hive.agent.*;
import net.hivecell.hive.cell.Cell;
import net.hivecell.hive.shadow.EventPublisherShadow;
import net.hivecell.hive.support.Debug;

import java.io.*;

/** Monitor that fires events when a file gets longer.
 ** This is like a really dumb "tail -f"
 **
 ** @version $Revision: 1.1 $
 ** @author Nelson Minar <nelson@media.mit.edu>
 **/
public interface FileGrowthShadow
extends EventPublisherShadow {
    
    /**
     * Get the value of fileToMonitor.
     *
     * @return Value of fileToMonitor.
     */
    public String getFileToMonitor();
    
    /**
     * Set the value of fileToMonitor.
     *
     * @param v Value to assign to fileToMonitor.
     */
    public void setFileToMonitor(String  v);

}
