// $Id: CricketShadow.java,v 1.1 2000/05/18 22:05:04 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.



package net.hivecell.hive.shadow.thing;

import net.hivecell.hive.cell.Cell;
import net.hivecell.hive.shadow.SerialStreamEventPublishingShadow;
import net.hivecell.hive.shadow.Shadow;
import net.hivecell.hive.shadow.ShadowInitializationException;
import net.hivecell.hive.support.Debug;

import java.io.*;

/** A simple shadow to talk to a cricket over the serial port.
 ** Currently, this shadow only *sends* bytes to the cricket, it can't
 ** receive from the cricket.
 **/
public interface CricketShadow 
extends SerialStreamEventPublishingShadow {

    /** Fake out isDeviceThere - ideally, we should handshake. **/
    public boolean isDeviceThere();

    /** The main method that this shadow exports; sending a byte out
     ** on the infrared of the serial port cricket.
     **/
    public void sendByteOnIR( byte b );
    
    public int readByteOnIR();

}
