// $Id: QuickCam.java,v 1.1 2000/05/18 22:05:04 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.shadow.thing;

import net.hivecell.hive.cell.Cell;
import net.hivecell.hive.shadow.Shadow;
import net.hivecell.hive.shadow.ShadowInitializationException;
import net.hivecell.hive.support.*;

import java.io.*;
import java.util.*;

/** A shadow for a quickcam, works by invoking a program (cqcam by default)
 ** that returns a PPM image on stdout.
 **/
public interface QuickCam 
extends Shadow {
    
    /**
     * Get the value of quickCamCommand.
     * @return Value of quickCamCommand.
     */
    public String getQuickCamCommand();
    
    /**
     * Set the value of quickCamCommand.
     * @param v  Value to assign to quickCamCommand.
     */
    public void setQuickCamCommand(String  v);

    public PPM getPPM();

}






