package net.hivecell.hive.agent;

import net.hivecell.hive.agent.Agent;
import net.hivecell.hive.support.CellAddress;

import java.rmi.RemoteException;


/**
 * the point of this interface is to return an agent which can connect
 * back to the agent which implements this interface.  see the
 * DJAgentImpl for an example 
 *
 * @see net.hivecell.hive.agent.DJAgentImpl;
 */
public interface DisplayExportingAgent {

    /**
     * this method is supposed to return an AgentImpl which we can
     * birth on our cell.  this agent should then make a connection
     * back to this agent to allow for remote manipulation.  see the
     * DJAgentImpl and its corresponding agent for an example
     *
     * @param requester the agent requesting the control agent
     * @param destination the address the agent should be sent to
     * @return the reference to the agent
     */
    public Agent sendUIAgent( Agent requester, CellAddress destination ) throws RemoteException;

}

