// $Id: EventTranslatingAgentImpl.java,v 1.1 2000/05/18 22:00:49 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent;
import net.hivecell.hive.event.HiveEvent;
import java.rmi.RemoteException;

/** Support for agents that receive events, translate them, and rebroadcast
 ** them. This class is now deprecated, in general you should use
 ** EventTransceivingAgentImpl instead.
 ** @deprecated
 ** @version $Revision: 1.1 $
 ** @author Nelson Minar <nelson@media.mit.edu>
 **/

public abstract class EventTranslatingAgentImpl extends EventTransceivingAgentImpl {
    public EventTranslatingAgentImpl() throws RemoteException { super(); }

    /** The translator method - called with the event data of a HiveEvent,
     ** this method should repropagate the event data through
     ** eventSendingHelper.notifySubscribers().
     **/
    public abstract void translate(HiveEvent event);

    public void doBehavior() {
        // By default, translator has no behavior, it's event driven.
    }
    
    /** When an event is received, call translate with the event data. **/
    public void notify(HiveEvent event) {
        super.notify(event);
        translate(event);
    }
}
