// $Id: SignalPassthrough.java,v 1.1 2000/05/18 22:00:49 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.


package net.hivecell.hive.agent;
import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.shadow.*;
import net.hivecell.hive.*;
import java.util.*;

/** An adapter class between shadow signals and agent events. When this
 ** agent receives a signal, it just passes on the data as an event.
 **/
public abstract class SignalPassthrough
extends EventSendingAgentImpl 
implements Signalable {

  public SignalPassthrough()
  throws java.rmi.RemoteException { 
      super(); 
  }

  /** When a signal is received, broadcast the event. **/
  public void signal( EventPublisherShadow source, Object information ) {
      eventSendingHelper.broadcastEvent( information );
  }

  /** Convenience method, if the signal source doesn't send an object
    * then just send null along.
    **/
  public void signal( EventPublisherShadow source ) {
    signal( source, null );
  }
}

