package net.hivecell.hive.agent.cell;

import net.hivecell.hive.agent.Agent;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * this is the remote interface to the AgentMessagingShadowAgent, it
 * will provide the information on what port number you should use if
 * you plan to send events to the cell that this agent is on 
 */
public interface AgentMessagingShadowAgent 
extends Remote, CellAgent {

    /**
     * this is the method that other AgentMessagingShadowAgents will
     * be calling to figure out what port to use to send HiveEvents to
     * this cell.
     *
     * @param a the agent that is requesting this information 
     */
    public int getAgentMessagingPort( Agent a )
    throws RemoteException;

}
