// $Id: CellAgent.java,v 1.1 2000/05/18 22:00:51 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.cell;

/**
 * This interface is used to tag those agents which are "privledged".
 * The reason this is used is for the session management support.
 * When the AgentGraph records the agents which are in the system, it
 * will inevitably record the UIManagerAgent and the CellListAgent.
 * These will be restored by the Cell itself, so the
 * SerializingAgentGraph has to realize which ones it should
 * <i>not</i> restore .  I'm assuming (I'm hoping I'm right), is that
 * only one type of a "privledged" agent will be active on a server at
 * one time.  Please tell me if I'm wrong.  
 *
 * @see net.hivecell.hive.cell.SerializingAgentGraph
 * @author Raffi Krikorian <raffi@media.mit.edu>
 */
public interface CellAgent {

}
