// $Id: CellControlAgent.java,v 1.1 2000/05/18 22:00:51 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.agent.cell;

import net.hivecell.hive.agent.Agent;
import net.hivecell.hive.agent.AgentImpl;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.support.CellAddress;
import net.hivecell.hive.cell.AgentDeliveryException;
import net.hivecell.hive.cell.RemoteCell;
import net.hivecell.hive.description.Description;

import java.rmi.Remote;
import java.rmi.RemoteException;


/**
 * The agent which will provide the remote access to the
 * CellControlShadow.  If any security is to be done to "protect"
 * the cell, it needs to be done here.
 **/
public interface CellControlAgent
extends Remote, CellAgent {

    public void shutDownCell() throws RemoteException;
    public Agent createAgent( String agentName ) throws ClassNotFoundException, InstantiationException, RemoteException;
    public Agent createAgent( String agentName, Description description ) throws ClassNotFoundException, InstantiationException, RemoteException;
    public void killAgent( Agent agent ) throws RemoteException;
    public Agent moveAgent( Agent agent, CellAddress serverAddress ) throws RemoteException, AgentDeliveryException;
    public boolean connectAgents( Agent from, Agent to ) throws RemoteException;
    public void disconnectAgentAll( Agent agent ) throws RemoteException;
    public void disconnectAgents( Agent from, Agent to ) throws RemoteException;

}

