// $Id: BaseConnection.java,v 1.1 2000/05/18 22:00:53 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

/**
 ** Base class for connections in a "Boxes and Lines" UI.
 **/

package net.hivecell.hive.agent.hiveui.iconicui;

import java.awt.*;

import net.hivecell.hive.agent.*;


public abstract class BaseConnection {

    protected BaseAgentIcon fromIcon;
    protected BaseAgentIcon toIcon;

    /**
     ** Constructor should be called by the LayoutManager.
     ** Responsible for drawing the arrow between the agents for the first time.
     **
     ** @param from source agent
     ** @param to destination agent
     **/
    public BaseConnection(BaseAgentIcon from, BaseAgentIcon to) {
	fromIcon = from;
	toIcon = to;
    }


    /** Gets the source icon **/
    public BaseAgentIcon getFromIcon() { return (fromIcon); }
    /** Gets the destination icon **/
    public BaseAgentIcon getToIcon() { return (toIcon); }

    public boolean equals( Object o ) {
	
	if( !(o instanceof BaseConnection ) )
	    return false;

	BaseConnection bc = (BaseConnection)o;
	if( bc.fromIcon.equals( fromIcon ) && bc.toIcon.equals( toIcon ) ) 
	    return true;

	return false;

    }

}
