// $Id: GraphicalConnectionArrow.java,v 1.1 2000/05/18 22:00:53 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

/**
 ** Simplest graphical arrow representing agent connections, just like from AWTUIAgentImpl.
 **/

package net.hivecell.hive.agent.hiveui.iconicui;

import java.awt.*;
import net.hivecell.hive.support.*;


public class GraphicalConnectionArrow extends BaseConnection {

    public static final Color startColor = Color.red;
    protected Color color;    

    BaseGraphicalArrow arr;

    public GraphicalConnectionArrow(BaseAgentIcon from, BaseAgentIcon to) {
	super(from, to);
	arr = new BaseGraphicalArrow(from, to);
	arr.connectDirection(from, to);

	color = startColor;
    }


    /**
     ** Sets the color of the arrow.  
     **
     ** @param c the new color to set to.
     **/
    public void setColor(Color c) { color = c; }
    /**
     ** Gets the current color of the arrow.
     ** The layout manager will determine how to draw it.
     **/
    public Color getColor() { return (color); }


    /** Draw the arrow representing the message between two agents. **/    
    public void draw(Graphics g) { arr.drawSelf(g); }

    /** Update the arrow representing the message between two agents (for animation)**/    
    public void update(Graphics g) { arr.drawSelf(g); }

    /** Update the arrow to represent a disconnection between two agents. **/
    public void eraseArrow(Graphics g) { arr.disconnectDirection( fromIcon, toIcon ); }
    
    /** Show that a message is being passed between fromIcon and toIcon */    
    public void message(BaseAgentIcon from, BaseAgentIcon to) {	arr.noteLinkUsed(from, to); }

}
