// $Id: AgentThreadGroup.java,v 1.1 2000/05/18 22:01:03 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.cell;
import net.hivecell.hive.support.*;
import java.lang.*;

/** Wrapper for thread group to have our own error output on uncaught
 ** exceptions.
 **
 ** @version $Revision: 1.1 $
 ** @author Nelson Minar <nelson@media.mit.edu>
 **/
public class AgentThreadGroup extends ThreadGroup {
  public AgentThreadGroup(String s) {
    super(s);
  }
  
  public void uncaughtException(Thread t, Throwable e) {
      if (e instanceof java.lang.ThreadDeath) {
          Debug.warning("Agent thread " + t + " threw a ThreadDeath. This probably means the agent did not die properly.");
          // Not printing stack trace - not working?!
      } else {
          Debug.error("Uncaught exception from agent in thread " + t, e);
      }
  }
}
