// $Id: QueryAgentsHelper.java,v 1.1 2000/05/18 22:01:04 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.cell;

import net.hivecell.hive.agent.Agent;

import net.hivecell.hive.description.RemoteDescribable;
import net.hivecell.hive.description.Description;
import net.hivecell.hive.description.AgentSet;
import java.rmi.RemoteException;
//  import net.hivecell.hive.rdf.Description;
//  import net.hivecell.hive.rdf.DescSet;
//  import net.hivecell.hive.rdf.Lookup;
import net.hivecell.hive.cell.AgentDescriptionPair;
import net.hivecell.hive.support.CellAddress;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.support.Null;

import java.util.Enumeration;
import java.util.Vector;

/**
 * This class is a helper class to off load the work for querying
 * agents from the Cell and the AgentMonitoringAgent 
 */
public class QueryAgentsHelper {

    /**
     * This is the standard query agents -- it takes an enumeration of
     * agents and performs the syntatic and semantic queries on them
     * to form a desc set of the matching agents
     *
     * @param agentsEnumeration the enumeration of agents to search
     * @param syntatic the syntatic matching scheme to search on
     * @param semantic the semntic matching scheme
     * @return the desc set of agents which match the two schemes
     * @exception NoSuchClassException if syntatic description is of a non-existing class 
     */
    public static AgentSet queryAgents( Enumeration agentsEnumeration, String[] syntactic, String[] semantic ) 
	throws ClassNotFoundException {
	
	// NEW, 2/27, by Tucker: No more AgentDescriptionPairs!  Cacheing
	// will be done differently, so until we find a new/better way
	// to do it, descriptions MUST be retrieved thru a remote call to the agent.

	// OBSOLETE DESCRIPTION OF THE WORKINGS OF QUERYAGENTS (MOST OF WHICH IS NOW IN XMLDESCSET ANYWAYS).
	// the enumeration of agents coming in will either be an
	// enumeration of Agents or an enumeration of
	// AgentDescriptionPairs -- it will never be a mix..  the
	// enumeration of agnets will be coming from the server and
	// the enumeration of agent description paris will come from
	// the server event info agent
	
	boolean isCell = true;
	Vector res = new Vector(); // these are the agents that will be put into the desc set
	Vector des = new Vector(); // these are their corresponding drescriptions

	// Now, test all the agents in the system..
	AgentSet agentsSet = new AgentSet();
	while( agentsEnumeration.hasMoreElements() ) {
	    Object o = agentsEnumeration.nextElement();    
	    Agent a = null;

	    if( o instanceof Agent ) {
		a = (Agent)o;
		agentsSet.addDesc( (RemoteDescribable)a );

	    } else {
		Debug.error( "Enumeration for the queryAgents contains a non agent in the agentsEnumeration!" );
		return null;
	    }
	}
	return(agentsSet.querySet(syntactic, semantic));
    }
}
