#!/usr/bin/perl -w

use strict;

# the first item in this array needs to be the destination directory
# for all the preprocessed files, the rest of them are the files to be
# pre-processed.
# Example commandline: ./debugPreProcessor.pl /tmp/preProcess <all java files from hive base>
if (@ARGV == 0) {
    print "USAGE: $0 <destination file> <files to convert>\n";
    print "(Ex. $0 /tmp/preProcess <all java files from hive base>)\n";
    exit;
}
my $destination_directory = shift @ARGV;

# now go through the list of the files that we want to preprocess,
# figure out the directory structure, make the directory then
# preprocess it
( $destination_directory ) = ( $destination_directory =~ /^(.*?)\/?$/ );
$destination_directory .= "/";
foreach my $file( @ARGV ) {
    # create the appropriate directories -- eww - the while loop is ugly, but 
    # i'm too brain dead to optimse it right now
    $file =~ /^(?:\.\/)?(.*?\/)(\w+.java)$/;
    my $subdirectories = $1;
    my $target_directory = $destination_directory . $1;
    my $filename = $2;
    my $target_file = $target_directory . $2;
    my @directories = reverse( split /\//, $subdirectories );
    if( $#directories > -1 ) {
	my $needed_directory = $destination_directory . pop( @directories );
	mkdir $needed_directory, 0755 if( !( -e $needed_directory ) && !( -d $needed_directory ) );
	while( $#directories > -1 ) {
	    $needed_directory .= "/" . pop( @directories );
	    mkdir $needed_directory, 0755 if( !( -e $needed_directory ) && !( -d $needed_directory ) );
	    
	}

    }

# This replaces the above while loop, but isn't portable.  Next person to have the urge
# to mess with this stupid script can find perl's equivalent... ;)
#    system("mkdirhier $target_directory") if ( !(-e $target_directory) && !(-d $target_directory) );

    
    # open the file, run it through the regexp and output it to the target directory
    my @mode = ( 'normal' );  # the mode stack
    my $lineNum = 0; # the line number we are scanning

    open INFILE, "<$file";
    open OUTFILE, ">$target_file";

    while( <INFILE> ) {
	$lineNum++;

        # parse out the debug statement
	my $prev = $_;
	if( /(                                        # ($1) recognising the Debug call:
	     (?:edu\.mit\.media\.hive\.support\.Debug)#    match a fully resolved call
	     |                                        #   or
	     (?:                                      #   (recognise function call)
	      (?:[^.]\bDebug)                         #     no dot, (? for left justified), and word boundary before 'Debug'
	      |                                       #     or
	      (?:^Debug)                              #     'Debug' is left justified
	      )		                              # end 3rd group, which avoids matching foo.Debug(), fooDebug()
	     )                                        # end 1st group, recognizing Debug call.
	    \.([^\(]+)                                # $2: which Debug method is being called
	    \((.+)                                    # $3: the argument list, or the first line of it (all we need).
	    /x ) {                                    # end regex (ignore comments)


# Got the debug statement, test to see if it's one that we need to do the substitution on, and then do it.

	    if( ( $2 eq "notice" ) ||
		( $2 eq "warning" ) ||
		( $2 eq "error" ) ||
		( $2 eq "critical" ) ||
		( $2 eq "failure" ) ) {
		s/(                                         # ($1) recognising the Debug call:
		   (?:edu\.mit\.media\.hive\.support\.Debug)#    match a fully resolved call
		   |                                        #   or
		   (?:                                      #   (recognise function call)
		    (?:[^.]\bDebug)                         #     no dot, (? for left justified), and word boundary before 'Debug'
		    |                                       #     or
		    (?:^Debug)                              #     'Debug' is left justified
		    )		                            # end 3rd group, which avoids matching foo.Debug(), fooDebug()
		   )                                        # end 1st group, recognizing Debug call.
		 \.([^\(]+)                                 # $2: which Debug method is being called
		 \((.+)                                     # $3: the argument list, or the first line of it (all we need).
		 /$1.'.explicit( net.hivecell.hive.support.Debug.'.uc($2).",$lineNum\,\"$filename\"\,$3"
		 /ex;                                       # end regex (Ignore comments)

	    }
	}
	
	print OUTFILE;

    }

    close OUTFILE;
    close INFILE;
}
