// $Id: RemoteEvent.java,v 1.1 2000/05/18 22:01:07 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.event;
import net.hivecell.hive.support.Debug;

/** The RemoteEvent class encapsulates the data for a remote event.
 ** This interface is part of the Jini Distributed Event system;
 ** if we integrate Jini, this class should be removed.
 **
 ** @version $Revision: 1.1 $
 ** @author Nelson Minar <nelson@media.mit.edu>
 **/
public class RemoteEvent extends java.util.EventObject {
  private Object source;
  protected long eventID;
  private long seqNum;
  private MarshalledObject handback;
  
  public RemoteEvent(Object source, long eventID, long seqNum, MarshalledObject handback) {
    super(source);
    this.source = source;
    this.eventID = eventID;
    this.seqNum = seqNum;
    this.handback = handback;
  }

  /** Who sent the event. In Hive, this is always an Agent. **/
  public Object getSource() { return source; }

  /** What's the event ID. **/
  public long getID() {
    return eventID;
  }

  /** The sequence number for the event. **/
  public long getSequenceNumber() {
    return seqNum;
  }

  /** The handback requested by the event listener. **/
  public MarshalledObject getRegistrationObject() {
    return handback;
  }
}
