// $Id: CellBornCellEvent.java,v 1.1 2000/05/18 22:01:08 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.event.cell;

import net.hivecell.hive.agent.Agent;
import net.hivecell.hive.support.CellAddress;

public class CellBornCellEvent 
extends CellEvent {

    private CellAddress serverBorn; // the address of the server this agent was born on

    /**
     * Create an agent born server event.
     *
     * @param broadcastingAgent the agent which is going to be sending out this event
     * @param eventCount the number of event which the helper is going to send out
     * @param serverBorn the address of the cell that was born
     */
    public CellBornCellEvent( Object broadcastingAgent, long eventCount, CellAddress serverBorn ) {

	super( broadcastingAgent, eventCount, CellEvent.SERVERBORN );
	this.serverBorn = serverBorn;

    }

    /**
     * Get the address to the cell that was born 
     *
     * @return the address of the cell
     */
    public CellAddress getAddress() { return this.serverBorn; }

    public boolean matchesCellAddress( CellAddress toTest ) {
	return getAddress().equals( toTest );
    }

    public CellAddress[] getCellAddresses() { 
	CellAddress[] toReturn = { serverBorn, };
	return toReturn;
    }

    public CellEvent createNewEvent( Object newSender, long eventCount ) {
	return new CellBornCellEvent( newSender, eventCount, getAddress() );
    }

}
