// $Id: CellGoingDownCellEvent.java,v 1.1 2000/05/18 22:01:08 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.event.cell;

import net.hivecell.hive.agent.Agent;
import net.hivecell.hive.support.CellAddress;

public class CellGoingDownCellEvent 
extends CellEvent {

    private CellAddress serverDown; // the address of the server this agent was born on
    
    /**
     * Create a server down server event.
     *
     * @param broadcastingAgent the agent which is going to be sending out this event
     * @param eventCount the number of event which the helper is going to send out
     * @param serverDown the address of the cell that is going down
     */
    public CellGoingDownCellEvent( Object broadcastingAgent, long eventCount, CellAddress serverDown ) {

	super( broadcastingAgent, eventCount, CellEvent.SERVERGOINGDOWN );
	this.serverDown = serverDown;

    }

    /**
     * Get the address to the cell that was born 
     *
     * @return the address of the cell
     */
    public CellAddress getAddress() { return this.serverDown; }

    public boolean matchesCellAddress( CellAddress toTest ) {
	return getAddress().equals( toTest );
    }

    public CellAddress[] getCellAddresses() { 
	CellAddress[] toReturn = { serverDown, };
	return toReturn;
    }

    public CellEvent createNewEvent( Object newSender, long eventCount ) {
	return new CellGoingDownCellEvent( newSender, eventCount, getAddress() );
    }

}


