// $Id: EventPublisherShadow.java,v 1.1 2000/05/18 22:01:12 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.shadow;

import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.description.Describable;
import net.hivecell.hive.support.Debug;

import java.util.Vector;
import java.util.Enumeration;

public interface EventPublisherShadow 
extends Describable, Shadow {

    /**
     * Clients can call this to add themselves as a listener to this type of event
     *
     * @param o the client
     */
    public void addListener( Signalable o );

    /**
     * Clients can call this to remove themselves as listeners of this event
     *
     * @param o the client
     * @return whether or not the object was actually removed
     */
    public boolean removeListener( Signalable o );

    /**
     * Get a count of all the events sent out
     *
     * @return the count
     */
    public int getCount();

    /**
     * Send a null event out to all subscribers
     */
    public void notifySubscribers();

    /**
     * Send a specific object out to the subscribers
     *
     * @param information the object to send
     */
    public void notifySubscribers( Object information );

}





