// $Id: ProcessStreamShadowImpl.java,v 1.1 2000/05/18 22:01:12 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.shadow;

import net.hivecell.hive.cell.Cell;
import net.hivecell.hive.support.Debug;

import java.lang.Process;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.StringTokenizer;

public abstract class ProcessStreamShadowImpl
extends StreamShadowImpl
implements ProcessStreamShadow {

    protected Process process;
    protected String processCommand;

    /**
     * get which command we are using for this stream shadow
     *
     * @return the command that we are using to communicate to the process
     */
    public String getProcessCommand() { return processCommand; }

    /**
     * set which command we are using for the stream shadow
     *
     * @param command the name of the command we are using
     */
    public void setProcessCommmand( String command ) { this.processCommand = command; }

    /**
     * do the initialization -- in this case it sets up the serial port
     */
    public void init() 
    throws ShadowInitializationException {
	Debug.notice( "running command " + processCommand );
	StringTokenizer st = new StringTokenizer( processCommand );
	int ntok;
	String[] cmd = new String[ntok = st.countTokens()];
	for( int i=0;i<ntok;i++ ) cmd[i] = st.nextToken();
	try {
	    process = Runtime.getRuntime().exec( cmd );
	    is = process.getInputStream();
	    os = process.getOutputStream();
	} catch( Exception e ) {
	    Debug.error( "command exec failed: " + e );
	    throw new ShadowInitializationException( "command exec failed: " + e );
	}

    }

}


