package net.hivecell.hive.shadow;

import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.cell.Cell;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import javax.comm.*;
import java.util.Vector;

public interface SerialStreamEventPublishingShadow
extends SerialStreamShadow, EventPublisherShadow {
    
    /**
     * Clients can call this to add themselves as a listener to this type of event
     *
     * @param o the client
     */
    public void addListener( Signalable o );

    public Vector getListeners();    
    
    /**
     * Clients can call this to remove themselves as listeners of this event
     *
     * @param o the client
     * @return whether or not the object was actually removed
     */
    public boolean removeListener( Signalable o );
    
    /**
     * Get a count of all the events sent out
     *
     * @return the count
     */
    public int getCount();
    
    /**
     * Send a null event out to all subscribers
     */
    public void notifySubscribers();
    
    /**
     * Send a specific object out to the subscribers
     *
     * @param information the object to send
     */
    public void notifySubscribers( Object information );
    
    
}
