package net.hivecell.hive.shadow;

import net.hivecell.hive.event.HiveEvent;
import net.hivecell.hive.support.Debug;
import net.hivecell.hive.cell.Cell;

import net.hivecell.hive.shadow.EventPublisherHelper;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import javax.comm.*;
import java.util.Vector;

public abstract class SerialStreamEventPublishingShadowImpl 
extends SerialStreamShadowImpl 
implements EventPublisherShadow, SerialStreamEventPublishingShadow {    
    
    /**
     * the event publishing helper that we keep around
     */
    EventPublisherHelper eph = new EventPublisherHelper( this );
    
    /**
     * Clients can call this to add themselves as a listener to this type of event
     *
     * @param o the client
     */
    public void addListener( Signalable o ) { eph.addListener( o ); }

    public Vector getListeners() {
        return eph.getListeners();
    }
    

    
    /**
     * Clients can call this to remove themselves as listeners of this event
     *
     * @param o the client
     * @return whether or not the object was actually removed
     */
    public boolean removeListener( Signalable o ) { return eph.removeListener( o ); }
    
    /**
     * Get a count of all the events sent out
     *
     * @return the count
     */
    public int getCount() { return eph.getCount(); }
    
    /**
     * Send a null event out to all subscribers
     */
    public void notifySubscribers() { eph.notifySubscribers(); }
    
    /**
     * Send a specific object out to the subscribers
     *
     * @param information the object to send
     */
    public void notifySubscribers( Object information ) { eph.notifySubscribers( information ); }
    
    
}
