// $Id: SerialStreamShadow.java,v 1.1 2000/05/18 22:01:12 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.shadow;

import net.hivecell.hive.cell.Cell;
import net.hivecell.hive.support.Debug;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import javax.comm.*;

public interface SerialStreamShadow
extends StreamShadow {

    /**
     * get the baud rate for this serial port
     *
     * @return the baud rate
     */
    public int getBaudRate();

    /**
     * set the baud rate to set the serial port with
     *
     * @param br the baud rate to set it to
     */
    public void setBaudRate( int br );

    /**
     * get which serial port we are configured at 
     * 
     * @return the serial port number
     */
    public int getSerialPort();

    /**
     * set which serial port we are configured at
     *
     * @param s the serial port that we are configured to
     */
    public void setSerialPort( int s );

}

