package net.hivecell.hive.shadow;

import net.hivecell.hive.agent.AgentImpl;
import net.hivecell.hive.description.Describable;
import net.hivecell.hive.description.Description;

public abstract class ShadowStub
implements Describable {

    /**
     * the implementation of this stub that we will pass things through to
     */
    protected ShadowImpl implementation;


    /**
     * create a new stub for us to work through -- this stub will just
     * pass calls through to the implementation 
     *
     * @param implementation the shadow we are proxying
     */
    public ShadowStub( ShadowImpl implementation ) {
	this.implementation = implementation;

    }

    /**
     * Get the value of description
     *
     * @return Value of desc.
     */
    public Description getDescription() { 
	return this.implementation.getDescription();

    }
    
    /**
     * Set the value of description.
     *
     * @param v the value to assign to the description.
     */
    public void setDescription( Description v ) { 
	this.implementation.setDescription( v );
    
    }

    /**
     * get the default agent for this shadow
     *
     * @return ask the implementation for the agent
     */
    public AgentImpl getDefaultAgent() { 
	return this.implementation.getDefaultAgent();
	
    }

}
