// $Id: ComponentManagerShadow.java,v 1.1 2000/05/18 22:01:15 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.shadow.cell;

import java.awt.Component;
import java.awt.Frame;

import net.hivecell.hive.shadow.Shadow;

public interface ComponentManagerShadow
extends Shadow {

    /**
     * ask the agennt component manager shadow to render a component
     * for a specific object
     *
     * @param o the object
     * @param c the component
     * @param s the title of the frame that it is going to be stuck in 
     */
    public Frame acceptComponentFrom( Object o, Component c, String s );

    /** 
     * remove a component that an object has given us. only an object
     * can destroy it's own component. in this case, there is only one
     * component per object, but this might change in the future.
     *
     * @param o the object requesting the component be removed
     * @param c the component to remove
     */
    public void removeComponentFrom( Object o, Component c );

    /**
     * remove all the components for an object
     *
     * @param o the object
     */
    public void removeComponentsFrom( Object o );
    
}






