// $Id: CellConnectException.java,v 1.1 2000/05/18 22:01:17 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.


package net.hivecell.hive.support;

import java.net.ConnectException;

/**
 * This is used as a generic exception to be thrown at certain times
 * -- it will be encapsulating the real exception in this case 
 */
public class CellConnectException 
extends ConnectException {

    private Exception error = null;

    public CellConnectException() {
	super();
    }
    
    public CellConnectException( String arg ) {
	super( arg );
    }

    public CellConnectException( Exception error ) {
	this.error = error;
    }

    public Exception getException() {
	return this.error;
    }

}


