// $Id: AsyncResultListener.java,v 1.1 2000/05/18 22:01:20 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.support.async;

/** 
 * If an object wants to be notified that an async method finished, it
 * can use this interface to receive that notification.  Alternately,
 * it can inspect the AsyncResult object itself.  
 */
public interface AsyncResultListener {

    /**
     * Used for a call back from the AsyncResult when it has a result.
     * This is the same method whether or not it is an exception or a
     * regular result
     *
     * @param ar the asyncresult object which will have the
     * information 
     */
    public void asyncFinished( AsyncResult ar );

}
