// $Id: Graph.java,v 1.1 2000/05/18 22:01:21 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.support.graph;

import java.util.Enumeration;

public interface Graph {

    public int numberNodes();

    public Enumeration nodes();

    public Enumeration edges();

    public void addNode( Object o );

    public boolean removeNode( Object o );

    public boolean containsNode( Object o );

    public void connectNodes( Object o1, Object o2, int weight ) 
    throws NotInGraphException;

    public boolean isConnected( Object o1, Object o2 )
    throws NotInGraphException;

    public int getWeight( Object o1, Object o2 )
    throws NotInGraphException;

    public int disconnectNodes( Object o1, Object o2 )
    throws NotInGraphException;

    public Object[] listOutgoingNodes( Object o ) 
    throws NotInGraphException;

    public Object[] listIncomingNodes( Object o ) 
    throws NotInGraphException;

}
