// $Id: MenuCheckBoxItem.java,v 1.1 2000/05/18 22:01:22 tucker Exp $
// Hive. Copyright (c) 1998-1999, The Massachusetts Institute of Technology.
// All rights reserved. Distributed with no warranty, without even the
// implied warranty of merchantability or fitness for a particular purpose.
// For more details see COPYING.GPL, the GNU General Public License.

package net.hivecell.hive.support.menu;

import net.hivecell.hive.support.menu.MenuItem;

public abstract class MenuCheckBoxItem
implements MenuItem {

    /**
     * this represents the state of the check box that we are using
     */
    private boolean state;

    /**
     * the name that this menu item returns
     */
    private String menuItemName;


    /**
     * create a new check box menu item 
     *
     * @param name the name to create this menu item as
     * @param state the state at which the check box should be at
     */
    public MenuCheckBoxItem( String name, boolean state ) {

	this.menuItemName = name;
	this.state = state;

    }


    /**
     * get the name of the menu object
     * 
     * @return the name of the menu object
     */
    public String getName() { return this.menuItemName; }

    /**
     * get the state of the switch 
     *
     * @return the state of the switch
     */
    public boolean getState() { return this.state; }

    /**
     * get the state of the switch 
     *
     * @param state the state of the switch
     */
    public void setState( boolean state ) { this.state = state; }

    /**
     * just cause this menu item to do its stuff -- this will be
     * called whenever the menu item changes it state
     *
     * @return true if the command wwas invoked, false otherwise 
     */
    public abstract boolean invoke();

}
